#ifndef api_h
#define api_h
#include <stdint.h>

#include  "lac_param.h"
//  Set these three values apropriately for your algorithm
#define CRYPTO_SECRETKEYBYTES DIM_N+PK_LEN
#define CRYPTO_PUBLICKEYBYTES PK_LEN
#define CRYPTO_BYTES MESSAGE_LEN
#define CRYPTO_CIPHERTEXTBYTES CIPHER_LEN

// Change the algorithm name
#define CRYPTO_ALGNAME STRENGTH

int lacpke_keygen(unsigned char *pk, unsigned char *sk);
int lacpke_enc(unsigned char *c, unsigned long long *clen, const unsigned char *m, unsigned long long mlen, const unsigned char *pk);
int lacpke_dec(unsigned char *m, unsigned long long *mlen, const unsigned char *c, unsigned long long clen, const unsigned char *sk);

int kg(unsigned char *pk, unsigned char *sk);
//key generation with seed
int kg_seed(unsigned char *pk, unsigned char *sk, unsigned char *seed);
// encryption with seed
int pke_enc_seed(const unsigned char *pk, const unsigned char *m, unsigned long long mlen, unsigned char *c, unsigned long long *clen, unsigned char *seed);
int enc(const unsigned char *pk, const unsigned char *m, unsigned long long mlen, unsigned char *c, unsigned long long *clen);
int dec(const unsigned char *sk, const unsigned char *c, unsigned long long clen, unsigned char *m, unsigned long long *mlen);



int lackem_keygen(unsigned char *pk, unsigned char *sk);
int lackem_enc(unsigned char *ct, unsigned char *ss, unsigned char *pk);
int lackem_dec(unsigned char *ss, unsigned char *ct, unsigned char *sk);

int kem_enc_fo(const unsigned char *pk, unsigned char *k, unsigned char *c);
// fo encryption for cca security with seed
int kem_enc_fo_seed(const unsigned char *pk, unsigned char *k, unsigned char *c, unsigned char *seed);
// decrypt of fo mode
int kem_dec_fo(const unsigned char *pk, const unsigned char *sk, const  unsigned char *c, unsigned char *k);


int kex_keygen(unsigned char *pk, unsigned char *sk);
int ake_alice_send(unsigned char *pk, unsigned char *sk, unsigned char *pk_b, unsigned char *sk_a, unsigned char *c, unsigned char *k1);
int ake_bob_receive(unsigned char *pk_b, unsigned char *sk_b, unsigned char *pk_a, unsigned char *pk, unsigned char *c_in, unsigned char *c_out, unsigned char *k);
int ake_alice_receive(unsigned char *pk_a, unsigned char *sk_a, unsigned char *pk_b, unsigned char *pk, unsigned char *sk, unsigned char *c1, unsigned char *c_in, unsigned char *k1, unsigned char *k);


#endif /* api_h */