#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include "gen_test_data.h"
#include "lac_param.h"
#include "api.h"

uint32_t cpu_to_be32(uint32_t x)
{
	return (x << 24) | ((x << 8) & 0xff0000) | ((x >> 8) & 0xff00) | ((x >> 24) & 0xff);
}


#define NDATA 10

	//generate test data  of pke
	int gendata_pke()
	{
		unsigned char pk[CRYPTO_PUBLICKEYBYTES];
		unsigned char sk[CRYPTO_SECRETKEYBYTES];
		unsigned char m[CRYPTO_BYTES], k2[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES];
		unsigned long long c_byts, m_byts=CRYPTO_BYTES, pk_byts, sk_byts;
		int i;
		FILE *fp2;
		unsigned char       entropy_input[48];
		uint32_t len[1];

		printf("\ntest data of pke is generated in PKE_VEC_INFO.dat\n");
		
		fp2 = fopen("PKE_VEC_INFO.dat", "wb");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (int i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		//fprintf(fp, "SEED_L\n");
		len[0] = cpu_to_be32(48);
		fwrite(len, sizeof(uint32_t), 1, fp2);
		//fprintf(fp, "\nSEED\n");
		fwrite(entropy_input, sizeof(unsigned char), 48, fp2);
		for (int j = 0; j < NDATA; j++) {
			pke_keygen(pk, &pk_byts, sk, &sk_byts);
			rand_byts(CRYPTO_BYTES, m);
			pke_enc(pk, pk_byts, m, m_byts, c, &c_byts);
			pke_dec(sk, sk_byts, c, c_byts, k2, &m_byts);
			
			//fprintf(fp, "\nSK_LEN\n");
			len[0] = cpu_to_be32(sk_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nSK\n");
			fwrite(sk, sizeof(unsigned char), sk_byts, fp2);

			//fprintf(fp, "\nPK_LEN\n");
			len[0] = cpu_to_be32(pk_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			
			//fprintf(fp, "\nPK\n");
			fwrite(pk, sizeof(unsigned char), pk_byts, fp2);

			//fprintf(fp, "\nM_LEN\n");
			len[0] = cpu_to_be32(m_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			
			//fprintf(fp, "\nMessage\n");
			fwrite(m, sizeof(unsigned char), m_byts, fp2);

			//fprintf(fp, "\nC_LEN\n");
			len[0] = cpu_to_be32(c_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nCiphertext\n");
			fwrite(c, sizeof(unsigned char), c_byts, fp2);
		}

		fclose(fp2);
		return 0;
	}

	//generate test data of kem
	int gendata_kem()
	{
		unsigned char pk[CRYPTO_PUBLICKEYBYTES];
		unsigned char sk[CRYPTO_SECRETKEYBYTES];
		unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES];
		unsigned long long pk_byts, sk_byts, ss_byts, c_byts;
		unsigned char       entropy_input[48];
		int i;

		FILE *fp2;
		uint32_t len[1];

		//create kat file
		printf("\ntest data of kem is generated in KEM_VEC_INFO.dat\n");
		
		fp2 = fopen("KEM_VEC_INFO.dat", "wb");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		
		len[0] = cpu_to_be32(48);
		fwrite(len, sizeof(uint32_t), 1, fp2);
		//fprintf(fp, "\nSEED\n");
		fwrite(entropy_input, sizeof(unsigned char), 48, fp2);
		for (int j = 0; j < NDATA; j++) {
			kem_keygen(pk, &pk_byts, sk, &sk_byts);
			kem_enc(pk, pk_byts, k1, &ss_byts, c, &c_byts);
			kem_dec(sk, sk_byts, c, c_byts, k2, &ss_byts);

			//fprintf(fp, "\nSK_LEN\n");
			len[0] = cpu_to_be32(sk_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			
			//fprintf(fp, "\nSK\n");
			fwrite(sk, sizeof(unsigned char), sk_byts, fp2);
			

			//fprintf(fp, "\nPK_LEN\n");
			len[0] = cpu_to_be32(pk_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nPK\n");
			fwrite(pk, sizeof(unsigned char), pk_byts, fp2);
			

			//fprintf(fp, "\nC_LEN\n");
			len[0] = cpu_to_be32(c_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nCiphertext\n");
			fwrite(c, sizeof(unsigned char), c_byts, fp2);
			
			//fprintf(fp, "\nSession_Key_LEN\n");
			len[0] = cpu_to_be32(ss_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\n\nSession Key\n");
			fwrite(k1, sizeof(unsigned char), ss_byts, fp2);	
		}

		fclose(fp2);
		return 0;
	}

	//generate test data of ake
	int gendata_ake()
	{
		unsigned char pka[CRYPTO_PUBLICKEYBYTES], pkb[CRYPTO_PUBLICKEYBYTES];
		unsigned char ska[CRYPTO_SECRETKEYBYTES], skb[CRYPTO_SECRETKEYBYTES], pa[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb[CRYPTO_SECRETKEYBYTES];
		unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], ma[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES];
		unsigned long long pka_byts, ska_byts, pkb_byts, skb_byts, pa_byts, pb_byts, ma_byts, mb_byts, k1_byts, k2_byts;
		unsigned char       entropy_input[48];
		int i;

		FILE *fp2;
		uint32_t len[1];
		//create kat file
		printf("\ntest data of ake is generated in AKE_VEC_INFO.dat\n");
		fp2 = fopen("AKE_VEC_INFO.dat", "wb");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (int i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		len[0] = cpu_to_be32(48);
		fwrite(len, sizeof(uint32_t), 1, fp2);
		//fprintf(fp, "\nSEED\n");
		fwrite(entropy_input, sizeof(unsigned char), 48, fp2);

		for (int j = 0; j < NDATA; j++) {

			kex_init_a(pka, &pka_byts, ska, &ska_byts, pa, &pa_byts);
			kex_init_b(pkb, &pkb_byts, skb, &skb_byts, pb, &pb_byts);


			//wirte arrays
			//fprintf(fp, "\nAlice_SK_LEN\n");
			len[0] = cpu_to_be32(ska_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nSKA\n");
			fwrite(ska, sizeof(unsigned char), ska_byts, fp2);


			//fprintf(fp, "\nAlice_PK_LEN\n");
			len[0] = cpu_to_be32(pka_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nPKA\n");
			fwrite(pka, sizeof(unsigned char), pka_byts, fp2);


			//fprintf(fp, "\nBob_SK_LEN\n");
			len[0] = cpu_to_be32(skb_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nSKB\n");
			fwrite(skb, sizeof(unsigned char), skb_byts, fp2);


			//fprintf(fp, "\nBob_PK_LEN\n");
			len[0] = cpu_to_be32(pkb_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nPKB\n");
			fwrite(pkb, sizeof(unsigned char), pkb_byts, fp2);
			

			//fprintf(fp, "\nkex_init_a pa_len\n");
			len[0] = cpu_to_be32(pa_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\npa\n");
			fwrite(pa, sizeof(unsigned char), pa_byts, fp2);

			//fprintf(fp, "\nkex_init_b pb_len\n");
			len[0] = cpu_to_be32(pb_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\npb\n");
			fwrite(pb, sizeof(unsigned char), pb_byts, fp2);

			kex_send_a(pkb, pkb_byts, pa, &pa_byts, ma, &ma_byts);

			//fprintf(fp, "\nkex_send_a pa_len\n");
			len[0] = cpu_to_be32(pa_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nkex_send_a pa\n");
			fwrite(pa, sizeof(unsigned char), pa_byts, fp2);

			//fprintf(fp, "\nkex_send_a ma_len\n");
			len[0] = cpu_to_be32(ma_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nkex_send_a ma\n");
			fwrite(ma, sizeof(unsigned char), ma_byts, fp2);


			kex_send_b(pka, pka_byts, ma, ma_byts, pb, &pb_byts, mb, &mb_byts, k1, &k1_byts);

			//fprintf(fp, "\nkex_send_b pb_len\n");
			len[0] = cpu_to_be32(pb_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\npb\n");
			fwrite(pb, sizeof(unsigned char), pb_byts, fp2);

			//fprintf(fp, "\nkex_send_b mb_len\n");
			len[0] = cpu_to_be32(mb_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nkex_send_b mb\n");
			fwrite(mb, sizeof(unsigned char), mb_byts, fp2);

			kex_resp_a(mb, mb_byts, pa, &pa_byts, ma, &ma_byts, k2, &k2_byts);
			
			//fprintf(fp, "\nkex_resp_a ma_len\n");
			len[0] = cpu_to_be32(ma_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nkex_send_a ma\n");
			fwrite(ma, sizeof(unsigned char), ma_byts, fp2);


			//fprintf(fp, "\nsession_key_len\n");
			len[0] = cpu_to_be32(k2_byts);
			fwrite(len, sizeof(uint32_t), 1, fp2);
			//fprintf(fp, "\nsession_key\n");
			fwrite(k2, sizeof(unsigned char), k2_byts, fp2);

		}

		fclose(fp2);
		return 0;
	}
