#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <math.h>
#include "api.h"
#include "Alg.h"

int hex_char_value(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	else if (c >= 'a' && c <= 'f')
		return (c - 'a' + 10);
	else if (c >= 'A' && c <= 'F')
		return (c - 'A' + 10);
	return 0;
}

int hextodec(unsigned char * buff, int len) {
	int num = 0;
	for (int j = 0; j < len; j++) {
		num = num + buff[j]* pow((float)256, len - 1 - j);
	}
	return num;
}

int testpke() {

	FILE *fp = NULL;
	unsigned char buff[4];
	unsigned char seed[48];

	unsigned char pk[CRYPTO_PUBLICKEYBYTES], pk_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char sk[CRYPTO_SECRETKEYBYTES], sk_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES], c_t[CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	//unsigned long long mlen = MESSAGE_LEN, clen = CRYPTO_CIPHERTEXTBYTES;
	unsigned long long pk_byts = 0, sk_byts = 0, m_byts = CRYPTO_BYTES, c_byts = 0;

	fopen_s(&fp, "PKE_VEC_INFO.dat", "rb");
	//read seed_len
	int seed_len = 0, sk_len = 0, pk_len = 0, m_len = 0, c_len = 0, label = 0;

	fread(buff, sizeof(unsigned char), 4, fp);
	seed_len = hextodec(buff, 4);
	fread(seed, sizeof(unsigned char), seed_len, fp);
	rand_init(seed, seed_len);
	for (i = 0; i < 10; i++) {
		pke_keygen(pk, &pk_byts, sk, &sk_byts);
		rand_byts(CRYPTO_BYTES, k1);

		fread(buff, sizeof(unsigned char), 4, fp);
		sk_len = hextodec(buff, 4);
		fread(sk_t, sizeof(unsigned char), sk_len, fp);
		fread(buff, sizeof(unsigned char), 4, fp);
		pk_len = hextodec(buff, 4);
		fread(pk_t, sizeof(unsigned char), pk_len, fp);

		fread(buff, sizeof(unsigned char), 4, fp);
		m_len = hextodec(buff, 4);
		fread(k2, sizeof(unsigned char), m_len, fp);
		if (memcmp(sk_t, sk, CRYPTO_SECRETKEYBYTES) == 0) {
			//printf("\nsk_t is equal to sk. \n");
		}
		else {
			printf("\nsk_t is not equal to sk. \n");
			label = -1;
		}
		if (memcmp(pk_t, pk, CRYPTO_PUBLICKEYBYTES) == 0) {
			//printf("\npk_t is equal to pk. \n");
		}
		else {
			printf("\npk_t is not equal to pk. \n");
			label = -1;
		}

		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		pke_enc(pk_t, pk_byts, k2, m_byts, c, &c_byts);

		fread(buff, sizeof(unsigned char), 4, fp);
		c_len = hextodec(buff, 4);
		fread(c_t, sizeof(unsigned char), c_len, fp);
		if (memcmp(c, c_t, CRYPTO_CIPHERTEXTBYTES) == 0) {
			//printf("\nc is equal to c_t. \n");
		}
		else {
			printf("\nc is not equal to c_t. \n");
			label = -1;
		}

		pke_dec(sk_t, sk_byts, c_t, c_byts, k3, &m_byts);
		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}

int testkem() {

	FILE *fp = NULL;
	unsigned char buff[4];
	unsigned char seed[48];

	unsigned char pk[CRYPTO_PUBLICKEYBYTES], pk_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char sk[CRYPTO_SECRETKEYBYTES], sk_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES], c_t[CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	unsigned long long pk_byts = 0, sk_byts = 0, ss_byts, c_byts = 0, label = 0;

	fopen_s(&fp, "KEM_VEC_INFO.dat", "rb");

	int seed_len = 0, sk_len = 0, pk_len = 0, c_len = 0, ss_len = 0;
	//read seed_len
	fread(buff, sizeof(unsigned char), 4, fp);
	seed_len = hextodec(buff, 4);
	fread(seed, sizeof(unsigned char), seed_len, fp);
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {
		kem_keygen(pk, &pk_byts, sk, &sk_byts);

		kem_enc(pk, pk_byts, k1, &ss_byts, c, &c_byts);
		kem_dec(sk, sk_byts, c, c_byts, k2, &ss_byts);

		fread(buff, sizeof(unsigned char), 4, fp);
		sk_len = hextodec(buff, 4);
		
		fread(sk_t, sizeof(unsigned char), sk_len, fp);
		
		fread(buff, sizeof(unsigned char), 4, fp);
		pk_len = hextodec(buff, 4);
		fread(pk_t, sizeof(unsigned char), pk_len, fp);


		fread(buff, sizeof(unsigned char), 4, fp);
		c_len = hextodec(buff, 4);
		fread(c_t, sizeof(unsigned char), c_len, fp);

		fread(buff, sizeof(unsigned char), 4, fp);
		ss_len = hextodec(buff, 4);
		fread(k3, sizeof(unsigned char), ss_len, fp);
	
		if (memcmp(sk_t, sk, CRYPTO_SECRETKEYBYTES) == 0) {
			//printf("\nsk_t is equal to sk. \n");
		}
		else {
			printf("\nsk_t is not equal to sk. \n");
			label = -1;
		}

		if (memcmp(pk_t, pk, CRYPTO_PUBLICKEYBYTES) == 0) {
			//printf("\npk_t is equal to pk. \n");
		}
		else {
			
			printf("\npk_t is not equal to pk. \n");
			label = -1;
		}


		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		if (memcmp(c, c_t, CRYPTO_CIPHERTEXTBYTES) == 0) {
			//printf("\nc is equal to c_t. \n");
		}
		else {
			printf("\nc is not equal to c_t. \n");
			label = -1;
		}

		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}

int testake() {

	FILE *fp = NULL;
	unsigned char buff[4];
	unsigned char seed[48];

	unsigned char pka[CRYPTO_PUBLICKEYBYTES], pkb[CRYPTO_PUBLICKEYBYTES], pka_t[CRYPTO_PUBLICKEYBYTES], pkb_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char ska[CRYPTO_SECRETKEYBYTES], skb[CRYPTO_SECRETKEYBYTES], pa[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb[CRYPTO_SECRETKEYBYTES];
	unsigned char ska_t[CRYPTO_SECRETKEYBYTES], skb_t[CRYPTO_SECRETKEYBYTES], pa_t[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], ma[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES], ma_t[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb_t[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	long long int  error_num = 0;
	unsigned long long pka_byts, ska_byts, pkb_byts, skb_byts, pa_byts, pb_byts, ma_byts, mb_byts, k1_byts, k2_byts;

	unsigned long long pk_byts = 0, sk_byts = 0, c_byts = 0, label = 0;

	fopen_s(&fp, "AKE_VEC_INFO.dat", "rb");
	int seed_len = 0, sk_len = 0, pk_len = 0, c_len = 0, ss_len = 0, pa_len = 0, pb_len = 0, ma_len = 0, mb_len = 0;

	fread(buff, sizeof(unsigned char), 4, fp);
	seed_len = hextodec(buff, 4);
	fread(seed, sizeof(unsigned char), seed_len, fp);
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {
		kex_init_a(pka, &pka_byts, ska, &ska_byts, pa, &pa_byts);
		kex_init_b(pkb, &pkb_byts, skb, &skb_byts, pb, &pb_byts);

		// for a
		fread(buff, sizeof(unsigned char), 4, fp);
		sk_len = hextodec(buff, 4);
		fread(ska_t, sizeof(unsigned char), sk_len, fp);
		if (sk_len != kex_get_sk_byts()) {
			printf("sk_len is not equal to sk_byts\n");
			label = -1;
		}
		if (memcmp(ska_t, ska, ska_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin init_a ska_t is not equal to ska. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		pk_len = hextodec(buff, 4);
		fread(pka_t, sizeof(unsigned char), pk_len, fp);
		if (pk_len != kex_get_pk_byts()) {
			printf("pk_len is not equal to pk_byts\n");
			label = -1;
		}
		if (memcmp(pka_t, pka, pka_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin init_a pka_t is not equal to pka. \n");
			label = -1;
		}

		// for b
		fread(buff, sizeof(unsigned char), 4, fp);
		sk_len = hextodec(buff, 4);
		fread(skb_t, sizeof(unsigned char), sk_len, fp);
		if (sk_len != kex_get_sk_byts()) {
			printf("sk_len is not equal to sk_byts\n");
			label = -1;
		}
		if (memcmp(skb_t, skb, skb_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin init_b skb_t is not equal to skb. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		pk_len = hextodec(buff, 4);
		fread(pkb_t, sizeof(unsigned char), pk_len, fp);
		if (pk_len != kex_get_pk_byts()) {
			printf("pk_len is not equal to pk_byts\n");
			label = -1;
		}
		if (memcmp(pkb_t, pkb, pkb_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin init_b pkb_t is not equal to pkb. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		pa_len = hextodec(buff, 4);
		fread(pa_t, sizeof(unsigned char), pa_len, fp);
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\npa_t is equal to pa. \n");
		}
		else {
			printf("\npa_t is not equal to pa. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		pb_len = hextodec(buff, 4);
		fread(pb_t, sizeof(unsigned char), pb_len, fp);
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\npb_t is equal to pb. \n");
		}
		else {
			printf("\npb_t is not equal to pb. \n");
			label = -1;
		}

		kex_send_a(pkb, pkb_byts, pa, &pa_byts, ma, &ma_byts);

		fread(buff, sizeof(unsigned char), 4, fp);
		pa_len = hextodec(buff, 4);
		fread(pa_t, sizeof(unsigned char), pa_len, fp);
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin send_a pa_t is not equal to pa. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		ma_len = hextodec(buff, 4);
		fread(ma_t, sizeof(unsigned char), ma_len, fp);
		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin send_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin send_a ma_t is not equal to ma. \n");
			label = -1;
		}


		kex_send_b(pka, pka_byts, ma, ma_byts, pb, &pb_byts, mb, &mb_byts, k1, &k1_byts);
		fread(buff, sizeof(unsigned char), 4, fp);
		pb_len = hextodec(buff, 4);
		fread(pb_t, sizeof(unsigned char), pb_len, fp);
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\nin send_b pb_t is equal to pb. \n");
		}
		else {
			printf("\nin send_b pb_t is not equal to pb. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		mb_len = hextodec(buff, 4);
		fread(mb_t, sizeof(unsigned char), mb_len, fp);
		if (memcmp(mb_t, mb, mb_byts) == 0) {
			//printf("\nin send_b mb_t is equal to mb. \n");
		}
		else {
			printf("\nin send_b mb_t is not equal to mb. \n");
			label = -1;
		}


		kex_resp_a(mb, mb_byts, pa, &pa_byts, ma, &ma_byts, k2, &k2_byts);

		fread(buff, sizeof(unsigned char), 4, fp);
		ma_len = hextodec(buff, 4);
		fread(ma_t, sizeof(unsigned char), ma_len, fp);
		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin resp_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin resp_a ma_t is not equal to ma. \n");
			label = -1;
		}

		fread(buff, sizeof(unsigned char), 4, fp);
		ss_len = hextodec(buff, 4);
		fread(k3, sizeof(unsigned char), ss_len, fp);

		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}
