﻿// test_dll1.cpp : 此文件包含 "main" 函数。程序执行将在此处开始并结束。
//

#include "pch.h"
#include "Alg.h"
#include "test_speed.h"
#include "test_correctness.h"
#include "gen_test_data.h"
#include "test_data.h"
#include <iostream>



#ifdef  __cplusplus
extern "C" {
#endif
#include "api.h"
#include "stdio.h"
//#include "test_correctness.h"
#ifdef  __cplusplus
}
#endif

int main()
{
	init();

	printf("==================== test %s ===================\n\n", STRENGTH);
	printf("------------------- PERFORMANCE -------------------\n\n");
	printf("PKE average speed of running 10000 times:\n");
	test_pke_speed();
	printf("KEM average speed of running 10000 times:\n");
	test_kem_speed();
	printf("KEX average speed of running 10000 times:\n");
	test_ke_speed();

	printf("\nPKE size in bytes: PK %lld SK %lld CT %lld\n", pke_get_pk_byts(), pke_get_sk_byts(), pke_get_ct_byts());
	printf("KEM size in bytes: PK %lld SK %lld CT %lld\n", kem_get_pk_byts(), kem_get_sk_byts(), kem_get_ct_byts());
	printf("KEX size in bytes: BW %lld\n", kex_get_bw_byts());



	printf("\n------------------ CORRECTNESS ------------------\n\n");
	test_pke_correctness();
	test_kem_correctness();
	test_ke_correctness();

	printf("\n--------------- GENERATE TEST DATA ---------------\n");
	gendata_pke();//gen pke data
	gendata_kem();//gen kem data
	gendata_ke();//gen ke data

	printf("\n\n--------------- DATA CORRECTNESS ----------------\n");
	//test data
	if (testpke() == 0) {
		printf("\nPKE data is correct\n");
	}
	else {
		printf("\n***************** test pke fail ******************\n");
	}

	if (testkem() == 0) {
		printf("\nKEM data is correct\n");
	}
	else {
		printf("\n***************** test kem fail ******************\n");
	}

	if (testke() == 0) {
		printf("\nKEX data is correct\n");
	}
	else {
		printf("\n***************** test ke fail ******************\n");
	}

	printf("\n======================================================\n");
	return 0;
	
}